﻿Imports System.Collections.ObjectModel

Public Class ViewModel

    Public Property Tickers As New ObservableCollection(Of ticker)
    Public RandomGenerator As New Random

    Sub New()

        Dim newTicker As New Ticker
        newTicker.Name = "A"
        newTicker.StartPrice = 100
        newTicker.StartDay = DateTime.Parse("01/01/2000")
        Tickers.Add(newTicker)
        AddMinutes(newTicker)

    End Sub

    Sub AddMinutes(inTicker As Ticker)
        Dim price As Single
        Dim procDateTime As DateTime = inTicker.StartDay
        Dim countDays As Integer = 0

        price = inTicker.StartPrice

        Debug.WriteLine("Adding Minutes...")

        Do

            Dim ChangeDirection As Integer = GetRandomInteger(0, 1)
            Dim Change As Double = GetRandomDouble(5)
            Select Case ChangeDirection
                Case 0
                    Change = Change
                Case 1
                    Change = -Change
            End Select

            price *= ((Change / 100) + 1)

            Dim newMinute As New Minute
            newMinute.DateTime = procDateTime
            newMinute.Price = price
            inTicker.Minutes.Add(newMinute)

            If procDateTime.Date < procDateTime.AddMinutes(1).Date Then
                price = 100
                inTicker.TotalDays += 1
            End If

            procDateTime = procDateTime.AddMinutes(1)

        Loop Until procDateTime = Today

        Debug.WriteLine("Adding Minutes Finished")

    End Sub

    Public Function GetRandomInteger(ByVal Min As Integer, ByVal Max As Integer) As Integer
        Return RandomGenerator.Next(Min, Max + 1)
    End Function

    Public Function GetRandomDouble(ByVal Max As Integer) As Double
        Return RandomGenerator.NextDouble() * Max
    End Function


End Class
